<?php
/**
 * This file is a part of the miniorange-saml-20-single-sign-on plugin.
 *
 * @link https://plugins.miniorange.com/
 * @author miniOrange
 * @package miniorange-saml-20-single-sign-on
 */


use RobRichards\XMLSecLibs\XMLSecurityKey;
use RobRichards\XMLSecLibs\XMLSecurityDSig;
use RobRichards\XMLSecLibs\XMLSecEnc;
class SAML2SPAssertion
{
    private $id;
    private $issueInstant;
    private $issuer;
    private $nameId;
    private $encryptedNameId;
    private $encryptedAttribute;
    private $encryptionKey;
    private $notBefore;
    private $notOnOrAfter;
    private $validAudiences;
    private $sessionNotOnOrAfter;
    private $sessionIndex;
    private $authnInstant;
    private $authnContextClassRef;
    private $authnContextDecl;
    private $authnContextDeclRef;
    private $AuthenticatingAuthority;
    private $attributes;
    private $nameFormat;
    private $signatureKey;
    private $certificates;
    private $signatureData;
    private $requiredEncAttributes;
    private $SubjectConfirmation;
    private $privateKeyUrl;
    protected $wasSignedAtConstruction = FALSE;
    public function __construct(DOMElement $jx = NULL, $L0)
    {
        $this->id = SAMLSPUtilities::generateId();
        $this->issueInstant = SAMLSPUtilities::generateTimestamp();
        $this->issuer = '';
        $this->authnInstant = SAMLSPUtilities::generateTimestamp();
        $this->attributes = array();
        $this->nameFormat = "\165\162\156\x3a\x6f\141\163\x69\163\72\x6e\x61\155\145\x73\x3a\164\x63\72\123\101\115\114\x3a\x31\x2e\61\x3a\156\141\x6d\x65\x69\x64\55\x66\157\x72\155\x61\164\72\165\156\163\160\x65\143\151\146\151\145\144";
        $this->certificates = array();
        $this->AuthenticatingAuthority = array();
        $this->SubjectConfirmation = array();
        if (!($jx === NULL)) {
            goto qn;
        }
        return;
        qn:
        if (!($jx->localName === "\x45\x6e\x63\x72\171\x70\164\x65\x64\x41\163\163\145\x72\x74\x69\157\156")) {
            goto bN;
        }
        $Br = SAMLSPUtilities::xpQuery($jx, "\x2e\57\x78\145\156\143\72\x45\156\x63\x72\171\160\x74\145\144\x44\x61\164\x61");
        $l4 = SAMLSPUtilities::xpQuery($jx, "\57\57\x2a\133\x6c\x6f\x63\141\x6c\55\156\x61\155\x65\x28\x29\75\x27\105\156\x63\162\x79\160\164\145\144\113\145\171\47\135\57\52\133\154\x6f\143\141\x6c\55\156\141\x6d\x65\x28\51\75\x27\x45\x6e\x63\162\x79\x70\164\151\x6f\x6e\x4d\x65\164\150\x6f\x64\x27\x5d\57\x40\101\154\147\x6f\162\151\x74\x68\x6d");
        $b6 = $l4[0]->value;
        $Ku = SAMLSPUtilities::getEncryptionAlgorithm($b6);
        if (count($Br) === 0) {
            goto yN;
        }
        if (count($Br) > 1) {
            goto Tx;
        }
        goto Gj;
        yN:
        throw new Mo_SAML_Invalid_Assertion_Exception("\x4d\x69\163\x73\151\156\x67\x20\145\156\x63\162\171\x70\164\x65\x64\x20\x64\141\x74\x61\x20\x69\156\x20\74\x73\x61\x6d\154\72\x45\156\x63\162\171\160\x74\145\x64\x41\163\163\145\x72\164\151\157\156\76\56");
        goto Gj;
        Tx:
        throw new Mo_SAML_Invalid_Assertion_Exception("\x4d\157\162\x65\x20\x74\150\141\156\x20\157\x6e\145\40\145\x6e\x63\x72\171\x70\164\145\144\x20\144\x61\x74\x61\40\145\x6c\x65\155\x65\156\164\40\151\156\40\x3c\163\141\x6d\154\72\x45\156\143\x72\171\x70\164\x65\x64\101\163\163\x65\162\164\x69\157\x6e\x3e\x2e");
        Gj:
        $mj = new XMLSecurityKey($Ku, array("\164\171\160\145" => "\160\162\x69\x76\x61\x74\145"));
        $mj->loadKey($L0, FALSE);
        $Ma = array();
        $fl = isset($_POST["\x52\x65\x6c\141\171\123\x74\141\164\145"]) ? $_POST["\x52\x65\154\141\x79\x53\164\141\164\x65"] : null;
        $jx = SAMLSPUtilities::decryptElement($Br[0], $mj, $Ma, null, $fl);
        bN:
        if ($jx->hasAttribute("\x49\104")) {
            goto UZ;
        }
        throw new Mo_SAML_Invalid_Assertion_Exception("\115\x69\163\163\151\x6e\147\x20\x49\x44\x20\141\x74\164\x72\x69\x62\165\164\145\40\157\156\x20\123\x41\115\114\40\141\x73\x73\145\162\164\151\157\156\56");
        UZ:
        $this->id = $jx->getAttribute("\111\x44");
        if (!($jx->getAttribute("\126\145\162\163\x69\157\x6e") !== "\62\x2e\x30")) {
            goto lv;
        }
        throw new Mo_SAML_Invalid_Assertion_Exception("\x55\x6e\163\165\x70\x70\x6f\x72\164\145\x64\40\x76\x65\x72\163\151\157\x6e\x3a\40" . $jx->getAttribute("\126\x65\x72\163\x69\x6f\x6e"));
        lv:
        $this->issueInstant = SAMLSPUtilities::xsDateTimeToTimestamp($jx->getAttribute("\x49\x73\163\x75\x65\111\x6e\x73\164\x61\156\164"));
        $rn = SAMLSPUtilities::xpQuery($jx, "\56\x2f\x73\x61\155\x6c\x5f\141\163\163\145\x72\164\x69\157\x6e\72\x49\163\x73\x75\145\162");
        if (!empty($rn)) {
            goto OA;
        }
        throw new Mo_SAML_Invalid_Assertion_Exception("\x4d\x69\x73\x73\151\x6e\x67\40\x3c\x73\x61\155\x6c\72\111\x73\x73\x75\145\x72\x3e\40\x69\x6e\40\141\x73\163\145\x72\x74\x69\157\x6e\x2e");
        OA:
        $this->issuer = trim($rn[0]->textContent);
        $this->parseConditions($jx);
        $this->parseAuthnStatement($jx);
        $this->parseAttributes($jx);
        $this->parseEncryptedAttributes($jx);
        $this->parseSignature($jx);
        $this->parseSubject($jx);
    }
    private function parseSubject(DOMElement $jx)
    {
        $Tu = SAMLSPUtilities::xpQuery($jx, "\56\57\x73\x61\x6d\154\137\141\163\163\x65\x72\x74\151\157\156\x3a\123\165\x62\x6a\145\143\164");
        if (empty($Tu)) {
            goto T5;
        }
        if (count($Tu) > 1) {
            goto BX;
        }
        goto PD;
        T5:
        return;
        goto PD;
        BX:
        throw new Mo_SAML_Invalid_Assertion_Exception("\115\157\x72\145\40\164\x68\141\x6e\x20\157\x6e\145\x20\74\163\x61\x6d\x6c\72\x53\165\x62\x6a\x65\x63\164\x3e\40\x69\156\40\74\163\x61\x6d\x6c\x3a\101\x73\x73\x65\162\x74\x69\x6f\x6e\76\56");
        PD:
        $Tu = $Tu[0];
        $IW = SAMLSPUtilities::xpQuery($Tu, "\x2e\x2f\x73\141\155\x6c\x5f\x61\163\163\145\162\164\151\x6f\156\x3a\x4e\x61\x6d\x65\x49\x44\x20\x7c\x20\x2e\57\x73\x61\155\154\137\x61\163\163\145\162\x74\x69\157\156\x3a\x45\156\x63\x72\x79\160\x74\x65\x64\111\x44\x2f\x78\x65\x6e\x63\x3a\105\x6e\x63\x72\171\x70\164\145\x64\104\141\x74\141");
        if (empty($IW)) {
            goto an;
        }
        if (count($IW) > 1) {
            goto BT;
        }
        goto F3;
        an:
        $xy = Mo_Saml_Error_Codes::$error_codes["\x57\120\123\101\x4d\114\x45\x52\122\60\x30\62"];
        $fl = $_POST["\122\145\154\x61\x79\x53\x74\141\164\145"];
        if ($fl === "\x74\x65\163\x74\126\141\x6c\x69\144\x61\164\145" or $fl === "\164\145\x73\x74\116\x65\167\103\x65\x72\x74\x69\x66\151\143\x61\164\x65") {
            goto n0;
        }
        mo_saml_display_end_user_error_message_with_code($xy);
        goto SU;
        n0:
        mo_saml_display_test_config_error($xy);
        SU:
        goto F3;
        BT:
        throw new Mo_SAML_Invalid_Assertion_Exception("\115\x6f\x72\145\40\x74\150\141\x6e\40\157\156\145\x20\74\163\x61\x6d\154\72\x4e\x61\155\x65\111\x44\76\x20\157\x72\x20\74\163\141\155\x6c\72\x45\x6e\x63\162\171\160\164\145\x64\104\x3e\x20\151\156\x20\74\x73\x61\x6d\x6c\x3a\123\165\142\152\x65\143\x74\x3e\x2e");
        F3:
        $IW = $IW[0];
        if ($IW->localName === "\x45\156\143\162\171\160\164\x65\x64\104\141\164\x61") {
            goto S8;
        }
        $this->nameId = SAMLSPUtilities::parseNameId($IW);
        goto oU;
        S8:
        $this->encryptedNameId = $IW;
        oU:
    }
    private function parseConditions(DOMElement $jx)
    {
        $hU = SAMLSPUtilities::xpQuery($jx, "\x2e\57\163\141\155\154\x5f\141\163\x73\x65\x72\x74\x69\157\156\x3a\103\157\156\x64\x69\164\x69\157\156\x73");
        if (empty($hU)) {
            goto ke;
        }
        if (count($hU) > 1) {
            goto fj;
        }
        goto iO;
        ke:
        return;
        goto iO;
        fj:
        throw new Mo_SAML_Invalid_Assertion_Exception("\x4d\157\162\x65\x20\164\150\x61\156\x20\157\x6e\x65\40\74\163\x61\155\154\72\x43\157\x6e\x64\x69\164\x69\157\156\163\76\40\x69\156\40\x3c\x73\x61\x6d\154\72\101\163\x73\x65\162\164\151\x6f\x6e\76\56");
        iO:
        $hU = $hU[0];
        if (!$hU->hasAttribute("\x4e\157\164\x42\x65\146\x6f\x72\x65")) {
            goto ii;
        }
        $L_ = SAMLSPUtilities::xsDateTimeToTimestamp($hU->getAttribute("\x4e\157\164\102\x65\146\x6f\162\145"));
        if (!($this->notBefore === NULL || $this->notBefore < $L_)) {
            goto xC;
        }
        $this->notBefore = $L_;
        xC:
        ii:
        if (!$hU->hasAttribute("\x4e\157\x74\x4f\x6e\117\162\x41\x66\164\x65\162")) {
            goto b9;
        }
        $jY = SAMLSPUtilities::xsDateTimeToTimestamp($hU->getAttribute("\x4e\x6f\x74\117\x6e\x4f\162\101\146\x74\x65\x72"));
        if (!($this->notOnOrAfter === NULL || $this->notOnOrAfter > $jY)) {
            goto js;
        }
        $this->notOnOrAfter = $jY;
        js:
        b9:
        $Vg = $hU->firstChild;
        IW:
        if (!($Vg !== NULL)) {
            goto v4;
        }
        if (!$Vg instanceof DOMText) {
            goto Bq;
        }
        goto dv;
        Bq:
        if (!($Vg->namespaceURI !== "\165\x72\156\x3a\x6f\141\x73\x69\163\72\x6e\x61\x6d\x65\163\72\164\143\x3a\x53\101\115\x4c\72\x32\56\60\x3a\x61\x73\163\x65\x72\x74\x69\157\156")) {
            goto JY;
        }
        throw new Mo_SAML_Invalid_Assertion_Exception("\x55\x6e\x6b\x6e\157\x77\x6e\40\x6e\141\155\145\x73\x70\x61\143\145\40\x6f\146\40\x63\x6f\x6e\x64\151\x74\x69\x6f\x6e\72\x20" . var_export($Vg->namespaceURI, TRUE));
        JY:
        switch ($Vg->localName) {
            case "\x41\165\144\x69\145\x6e\x63\145\x52\x65\163\x74\162\x69\x63\x74\151\157\156":
                $UQ = SAMLSPUtilities::extractStrings($Vg, "\165\162\x6e\72\x6f\141\x73\x69\163\72\x6e\x61\x6d\x65\x73\x3a\x74\143\72\123\x41\x4d\x4c\72\x32\x2e\x30\72\141\163\x73\x65\162\164\151\x6f\156", "\101\x75\144\x69\x65\156\143\145");
                if ($this->validAudiences === NULL) {
                    goto iL;
                }
                $this->validAudiences = array_intersect($this->validAudiences, $UQ);
                goto bD;
                iL:
                $this->validAudiences = $UQ;
                bD:
                goto lJ;
            case "\x4f\156\x65\x54\x69\x6d\x65\125\163\145":
                goto lJ;
            case "\120\x72\157\170\171\122\x65\163\164\162\151\x63\164\x69\x6f\x6e":
                goto lJ;
            default:
                throw new Mo_SAML_Invalid_Assertion_Exception("\125\x6e\153\156\x6f\167\156\40\x63\x6f\156\144\151\x74\151\157\x6e\72\40" . var_export($Vg->localName, TRUE));
        }
        Dt:
        lJ:
        dv:
        $Vg = $Vg->nextSibling;
        goto IW;
        v4:
    }
    private function parseAuthnStatement(DOMElement $jx)
    {
        $aB = SAMLSPUtilities::xpQuery($jx, "\56\x2f\163\141\x6d\x6c\137\x61\163\x73\x65\x72\x74\151\157\x6e\x3a\x41\165\164\150\156\123\164\x61\164\x65\155\145\156\164");
        if (empty($aB)) {
            goto ww;
        }
        if (count($aB) > 1) {
            goto FX;
        }
        goto oD;
        ww:
        $this->authnInstant = NULL;
        return;
        goto oD;
        FX:
        throw new Mo_SAML_Invalid_Assertion_Exception("\115\157\162\x65\40\164\150\141\x74\x20\157\x6e\x65\x20\x3c\x73\x61\x6d\x6c\x3a\101\165\164\150\156\123\164\141\164\x65\155\x65\x6e\x74\76\40\151\x6e\40\74\163\x61\x6d\x6c\x3a\x41\163\163\145\162\x74\151\157\x6e\76\x20\x6e\157\x74\x20\x73\165\x70\160\x6f\162\x74\x65\144\x2e");
        oD:
        $Up = $aB[0];
        if ($Up->hasAttribute("\x41\165\x74\150\156\x49\x6e\163\x74\x61\156\x74")) {
            goto rF;
        }
        throw new Mo_SAML_Invalid_Assertion_Exception("\115\x69\x73\163\151\156\147\40\x72\x65\161\x75\151\162\x65\144\x20\101\165\164\150\156\x49\156\163\x74\x61\x6e\x74\x20\x61\x74\x74\162\x69\142\x75\164\x65\40\157\x6e\40\x3c\163\141\155\x6c\72\101\165\x74\x68\156\123\x74\x61\x74\145\x6d\145\x6e\x74\76\x2e");
        rF:
        $this->authnInstant = SAMLSPUtilities::xsDateTimeToTimestamp($Up->getAttribute("\101\165\164\x68\156\111\x6e\163\x74\141\x6e\x74"));
        if (!$Up->hasAttribute("\x53\x65\x73\x73\151\x6f\x6e\116\x6f\164\x4f\156\x4f\x72\x41\146\164\145\162")) {
            goto pa;
        }
        $this->sessionNotOnOrAfter = SAMLSPUtilities::xsDateTimeToTimestamp($Up->getAttribute("\x53\x65\x73\163\151\157\x6e\116\x6f\x74\x4f\156\x4f\162\101\146\164\x65\162"));
        pa:
        if (!$Up->hasAttribute("\x53\145\163\x73\151\x6f\156\111\156\x64\x65\x78")) {
            goto NN;
        }
        $this->sessionIndex = $Up->getAttribute("\123\145\163\163\x69\x6f\x6e\x49\x6e\144\x65\170");
        NN:
        $this->parseAuthnContext($Up);
    }
    private function parseAuthnContext(DOMElement $I7)
    {
        $Wl = SAMLSPUtilities::xpQuery($I7, "\56\x2f\x73\141\155\x6c\x5f\x61\163\x73\x65\162\164\x69\x6f\156\x3a\x41\x75\x74\150\x6e\x43\x6f\x6e\164\145\x78\x74");
        if (count($Wl) > 1) {
            goto gp;
        }
        if (empty($Wl)) {
            goto C6;
        }
        goto p7;
        gp:
        throw new Mo_SAML_Invalid_Assertion_Exception("\x4d\157\x72\x65\x20\164\150\141\156\40\157\x6e\145\40\74\x73\x61\155\x6c\x3a\101\165\164\x68\156\x43\x6f\156\164\145\x78\164\76\40\151\156\40\74\163\x61\x6d\x6c\x3a\101\165\164\150\x6e\x53\164\141\x74\145\x6d\x65\x6e\x74\76\56");
        goto p7;
        C6:
        throw new Mo_SAML_Invalid_Assertion_Exception("\115\151\163\x73\151\x6e\x67\x20\162\145\x71\165\151\x72\145\144\x20\74\163\x61\x6d\154\x3a\x41\x75\x74\x68\x6e\x43\157\x6e\164\145\170\x74\76\x20\x69\x6e\40\x3c\x73\141\155\x6c\x3a\101\165\164\x68\x6e\123\164\x61\164\145\x6d\145\156\x74\x3e\56");
        p7:
        $Zb = $Wl[0];
        $HD = SAMLSPUtilities::xpQuery($Zb, "\56\57\163\x61\x6d\x6c\x5f\x61\163\163\145\162\x74\151\157\x6e\x3a\x41\x75\x74\150\x6e\x43\157\x6e\x74\145\x78\164\104\x65\143\x6c\x52\x65\x66");
        if (count($HD) > 1) {
            goto p_;
        }
        if (count($HD) === 1) {
            goto Z5;
        }
        goto sW;
        p_:
        throw new Mo_SAML_Invalid_Assertion_Exception("\115\x6f\x72\x65\x20\164\x68\x61\x6e\40\157\x6e\x65\x20\74\163\x61\x6d\x6c\x3a\x41\x75\164\150\156\x43\x6f\156\x74\x65\170\164\104\x65\x63\154\x52\145\146\x3e\x20\146\x6f\x75\x6e\x64");
        goto sW;
        Z5:
        $this->setAuthnContextDeclRef(trim($HD[0]->textContent));
        sW:
        $hr = SAMLSPUtilities::xpQuery($Zb, "\56\x2f\163\141\155\x6c\x5f\x61\163\163\145\162\x74\x69\157\x6e\72\101\x75\x74\x68\156\x43\x6f\156\x74\x65\170\164\104\145\143\154");
        if (count($hr) > 1) {
            goto P2;
        }
        if (count($hr) === 1) {
            goto Mp;
        }
        goto YT;
        P2:
        throw new Mo_SAML_Invalid_Assertion_Exception("\x4d\157\x72\145\40\x74\x68\141\156\x20\157\156\x65\x20\x3c\163\141\x6d\154\x3a\101\x75\164\x68\156\x43\157\x6e\x74\x65\170\164\x44\x65\143\x6c\x3e\x20\x66\157\x75\x6e\x64");
        goto YT;
        Mp:
        $this->setAuthnContextDecl(new SAML2_XML_Chunk($hr[0]));
        YT:
        $fi = SAMLSPUtilities::xpQuery($Zb, "\x2e\57\x73\141\x6d\154\x5f\x61\163\163\145\162\164\x69\x6f\156\x3a\101\165\164\x68\156\103\157\x6e\x74\145\170\x74\103\154\x61\x73\x73\x52\x65\146");
        if (count($fi) > 1) {
            goto WW;
        }
        if (count($fi) === 1) {
            goto zb;
        }
        goto ok;
        WW:
        throw new Mo_SAML_Invalid_Assertion_Exception("\x4d\157\x72\145\x20\x74\x68\x61\156\40\x6f\156\x65\40\74\x73\141\155\154\x3a\101\165\x74\150\x6e\x43\157\156\164\145\170\164\x43\154\x61\x73\x73\x52\145\x66\x3e\40\151\156\40\74\x73\141\x6d\x6c\x3a\x41\x75\164\150\156\103\157\156\x74\x65\170\x74\x3e\x2e");
        goto ok;
        zb:
        $this->setAuthnContextClassRef(trim($fi[0]->textContent));
        ok:
        if (!(empty($this->authnContextClassRef) && empty($this->authnContextDecl) && empty($this->authnContextDeclRef))) {
            goto iJ;
        }
        throw new Mo_SAML_Invalid_Assertion_Exception("\115\151\x73\163\x69\x6e\147\40\145\x69\164\150\x65\162\40\74\163\x61\155\x6c\72\x41\x75\x74\x68\x6e\103\157\156\x74\x65\x78\x74\x43\154\x61\x73\163\122\145\146\76\x20\157\162\x20\74\x73\x61\x6d\x6c\x3a\x41\x75\164\150\156\103\x6f\156\164\145\170\164\104\x65\143\x6c\x52\x65\146\x3e\x20\157\x72\40\x3c\x73\x61\155\154\72\x41\x75\x74\x68\156\103\x6f\156\x74\145\x78\164\104\x65\143\x6c\x3e");
        iJ:
        $this->AuthenticatingAuthority = SAMLSPUtilities::extractStrings($Zb, "\x75\162\156\72\157\141\163\151\163\x3a\x6e\x61\155\x65\x73\x3a\164\143\x3a\x53\x41\115\114\x3a\62\x2e\x30\72\x61\x73\x73\145\x72\164\151\x6f\156", "\101\x75\164\x68\145\x6e\164\x69\143\x61\x74\x69\156\147\x41\x75\x74\150\x6f\x72\151\x74\171");
    }
    private function parseAttributes(DOMElement $jx)
    {
        $jz = TRUE;
        $m6 = SAMLSPUtilities::xpQuery($jx, "\56\57\x73\x61\155\x6c\x5f\x61\163\163\x65\162\164\x69\157\x6e\72\101\164\x74\162\x69\142\165\x74\145\123\x74\x61\164\x65\x6d\x65\156\x74\x2f\x73\141\x6d\154\x5f\x61\163\x73\145\162\164\151\x6f\156\72\101\x74\164\162\151\x62\165\164\145");
        foreach ($m6 as $ZG) {
            if ($ZG->hasAttribute("\116\141\x6d\145")) {
                goto OB;
            }
            throw new Mo_SAML_Invalid_Assertion_Exception("\115\x69\163\163\x69\x6e\x67\x20\x6e\141\155\x65\x20\x6f\x6e\40\74\163\141\155\154\72\101\164\164\162\x69\142\165\164\145\x3e\40\x65\154\x65\155\145\x6e\164\x2e");
            OB:
            $KC = $ZG->getAttribute("\x4e\x61\x6d\x65");
            if ($ZG->hasAttribute("\116\141\155\145\106\157\x72\155\x61\164")) {
                goto j7;
            }
            $lp = "\x75\x72\x6e\72\x6f\141\163\151\163\72\x6e\141\x6d\x65\163\72\x74\x63\x3a\123\x41\x4d\114\72\61\56\x31\x3a\x6e\x61\x6d\x65\151\144\x2d\146\157\162\x6d\x61\164\72\165\156\x73\160\x65\143\x69\146\x69\x65\144";
            goto uw;
            j7:
            $lp = $ZG->getAttribute("\x4e\x61\x6d\145\x46\157\162\155\x61\x74");
            uw:
            if ($jz) {
                goto qZ;
            }
            if (!($this->nameFormat !== $lp)) {
                goto Dm;
            }
            $this->nameFormat = "\165\162\x6e\72\x6f\x61\x73\x69\x73\x3a\156\x61\155\x65\163\x3a\x74\143\x3a\123\x41\115\x4c\72\61\x2e\x31\72\156\141\155\x65\x69\144\x2d\146\x6f\162\155\x61\x74\x3a\x75\156\163\x70\145\x63\x69\x66\151\145\144";
            Dm:
            goto kz;
            qZ:
            $this->nameFormat = $lp;
            $jz = FALSE;
            kz:
            if (isset($this->attributes[$KC])) {
                goto zz;
            }
            $this->attributes[$KC] = array();
            zz:
            $BT = SAMLSPUtilities::xpQuery($ZG, "\x2e\x2f\x73\x61\155\154\x5f\141\163\163\x65\x72\x74\x69\157\156\72\x41\x74\164\162\x69\x62\165\x74\x65\x56\141\x6c\x75\145");
            foreach ($BT as $lj) {
                $this->attributes[$KC][] = trim($lj->textContent);
                sk:
            }
            yq:
            Za:
        }
        jN:
    }
    private function parseEncryptedAttributes(DOMElement $jx)
    {
        $this->encryptedAttribute = SAMLSPUtilities::xpQuery($jx, "\x2e\x2f\163\141\x6d\x6c\137\141\x73\163\145\162\x74\151\157\x6e\72\x41\164\x74\162\x69\142\165\x74\x65\x53\x74\141\x74\145\x6d\x65\x6e\164\x2f\x73\141\x6d\154\137\141\163\163\x65\162\164\151\157\156\x3a\x45\156\x63\x72\x79\160\164\145\144\x41\164\x74\x72\x69\x62\x75\x74\145");
    }
    private function parseSignature(DOMElement $jx)
    {
        $df = SAMLSPUtilities::validateElement($jx);
        if (!($df !== FALSE)) {
            goto On;
        }
        $this->wasSignedAtConstruction = TRUE;
        $this->certificates = $df["\103\145\x72\164\151\146\151\x63\141\164\x65\x73"];
        $this->signatureData = $df;
        On:
    }
    public function validate(XMLSecurityKey $mj)
    {
        if (!($this->signatureData === NULL)) {
            goto OX;
        }
        return FALSE;
        OX:
        SAMLSPUtilities::validateSignature($this->signatureData, $mj);
        return TRUE;
    }
    public function getId()
    {
        return $this->id;
    }
    public function setId($uS)
    {
        $this->id = $uS;
    }
    public function getIssueInstant()
    {
        return $this->issueInstant;
    }
    public function setIssueInstant($CF)
    {
        $this->issueInstant = $CF;
    }
    public function getIssuer()
    {
        return $this->issuer;
    }
    public function setIssuer($rn)
    {
        $this->issuer = $rn;
    }
    public function getNameId()
    {
        if (!($this->encryptedNameId !== NULL)) {
            goto zg;
        }
        throw new Mo_SAML_Invalid_Assertion_Exception("\101\164\x74\x65\155\x70\x74\145\144\40\x74\x6f\x20\162\145\x74\x72\151\145\166\x65\40\x65\156\x63\x72\171\x70\164\145\x64\40\x4e\x61\155\145\x49\104\x20\167\x69\x74\150\157\165\x74\x20\144\145\143\x72\x79\160\x74\151\x6e\x67\x20\x69\164\x20\x66\x69\162\163\164\x2e");
        zg:
        return $this->nameId;
    }
    public function setNameId($IW)
    {
        $this->nameId = $IW;
    }
    public function isNameIdEncrypted()
    {
        if (!($this->encryptedNameId !== NULL)) {
            goto EI;
        }
        return TRUE;
        EI:
        return FALSE;
    }
    public function encryptNameId(XMLSecurityKey $mj)
    {
        $dk = new DOMDocument();
        $Q8 = $dk->createElement("\162\x6f\157\x74");
        $dk->appendChild($Q8);
        SAMLSPUtilities::addNameId($Q8, $this->nameId);
        $IW = $Q8->firstChild;
        SAMLSPUtilities::getContainer()->debugMessage($IW, "\x65\x6e\143\x72\171\160\x74");
        $Ll = new XMLSecEnc();
        $Ll->setNode($IW);
        $Ll->type = XMLSecEnc::Element;
        $jp = new XMLSecurityKey(XMLSecurityKey::AES128_CBC);
        $jp->generateSessionKey();
        $Ll->encryptKey($mj, $jp);
        $this->encryptedNameId = $Ll->encryptNode($jp);
        $this->nameId = NULL;
    }
    public function decryptNameId(XMLSecurityKey $mj, array $Ma = array())
    {
        if (!($this->encryptedNameId === NULL)) {
            goto FW;
        }
        return;
        FW:
        $IW = SAMLSPUtilities::decryptElement($this->encryptedNameId, $mj, $Ma);
        SAMLSPUtilities::getContainer()->debugMessage($IW, "\x64\145\x63\162\171\160\x74");
        $this->nameId = SAMLSPUtilities::parseNameId($IW);
        $this->encryptedNameId = NULL;
    }
    public function decryptAttributes(XMLSecurityKey $mj, array $Ma = array())
    {
        if (!($this->encryptedAttribute === NULL)) {
            goto WM;
        }
        return;
        WM:
        $jz = TRUE;
        $m6 = $this->encryptedAttribute;
        foreach ($m6 as $x8) {
            $ZG = SAMLSPUtilities::decryptElement($x8->getElementsByTagName("\x45\156\143\162\171\x70\164\145\144\104\141\x74\x61")->item(0), $mj, $Ma);
            if ($ZG->hasAttribute("\x4e\x61\x6d\x65")) {
                goto xA;
            }
            throw new Mo_SAML_Invalid_Assertion_Exception("\x4d\x69\x73\x73\x69\156\147\x20\x6e\141\x6d\145\x20\157\x6e\40\x3c\x73\x61\x6d\x6c\x3a\101\x74\x74\x72\x69\x62\x75\x74\x65\76\40\145\x6c\145\x6d\x65\x6e\x74\x2e");
            xA:
            $KC = $ZG->getAttribute("\x4e\141\x6d\x65");
            if ($ZG->hasAttribute("\116\x61\x6d\145\x46\x6f\162\x6d\x61\x74")) {
                goto Gn;
            }
            $lp = "\165\162\x6e\72\x6f\141\x73\x69\x73\72\156\141\x6d\x65\163\72\x74\x63\72\x53\x41\115\x4c\x3a\x32\56\x30\72\x61\164\164\x72\x6e\141\155\145\55\146\x6f\x72\155\x61\164\72\x75\x6e\x73\160\145\x63\151\146\151\x65\x64";
            goto IU;
            Gn:
            $lp = $ZG->getAttribute("\116\x61\x6d\x65\x46\x6f\x72\x6d\141\164");
            IU:
            if ($jz) {
                goto Ox;
            }
            if (!($this->nameFormat !== $lp)) {
                goto SK;
            }
            $this->nameFormat = "\x75\x72\x6e\72\157\x61\x73\x69\163\72\156\141\155\145\x73\72\x74\143\x3a\x53\x41\115\114\x3a\62\56\60\72\141\x74\164\162\x6e\x61\x6d\x65\55\x66\x6f\162\155\x61\x74\72\x75\x6e\163\160\145\143\x69\146\151\145\x64";
            SK:
            goto nd;
            Ox:
            $this->nameFormat = $lp;
            $jz = FALSE;
            nd:
            if (isset($this->attributes[$KC])) {
                goto rq;
            }
            $this->attributes[$KC] = array();
            rq:
            $BT = SAMLSPUtilities::xpQuery($ZG, "\x2e\x2f\163\x61\155\154\x5f\141\163\x73\145\162\x74\151\x6f\156\x3a\x41\x74\x74\x72\x69\142\x75\x74\x65\x56\141\154\165\x65");
            foreach ($BT as $lj) {
                $this->attributes[$KC][] = trim($lj->textContent);
                is:
            }
            uj:
            Fu:
        }
        jQ:
    }
    public function getNotBefore()
    {
        return $this->notBefore;
    }
    public function setNotBefore($L_)
    {
        $this->notBefore = $L_;
    }
    public function getNotOnOrAfter()
    {
        return $this->notOnOrAfter;
    }
    public function setNotOnOrAfter($jY)
    {
        $this->notOnOrAfter = $jY;
    }
    public function setEncryptedAttributes($wL)
    {
        $this->requiredEncAttributes = $wL;
    }
    public function getValidAudiences()
    {
        return $this->validAudiences;
    }
    public function setValidAudiences(array $lo = NULL)
    {
        $this->validAudiences = $lo;
    }
    public function getAuthnInstant()
    {
        return $this->authnInstant;
    }
    public function setAuthnInstant($f3)
    {
        $this->authnInstant = $f3;
    }
    public function getSessionNotOnOrAfter()
    {
        return $this->sessionNotOnOrAfter;
    }
    public function setSessionNotOnOrAfter($uY)
    {
        $this->sessionNotOnOrAfter = $uY;
    }
    public function getSessionIndex()
    {
        return $this->sessionIndex;
    }
    public function setSessionIndex($MR)
    {
        $this->sessionIndex = $MR;
    }
    public function getAuthnContext()
    {
        if (empty($this->authnContextClassRef)) {
            goto Ag;
        }
        return $this->authnContextClassRef;
        Ag:
        if (empty($this->authnContextDeclRef)) {
            goto iH;
        }
        return $this->authnContextDeclRef;
        iH:
        return NULL;
    }
    public function setAuthnContext($P2)
    {
        $this->setAuthnContextClassRef($P2);
    }
    public function getAuthnContextClassRef()
    {
        return $this->authnContextClassRef;
    }
    public function setAuthnContextClassRef($wM)
    {
        $this->authnContextClassRef = $wM;
    }
    public function setAuthnContextDecl(SAML2_XML_Chunk $ef)
    {
        if (empty($this->authnContextDeclRef)) {
            goto ZI;
        }
        throw new Mo_SAML_Invalid_Assertion_Exception("\101\x75\x74\150\156\x43\157\156\164\145\170\164\104\145\143\x6c\122\x65\146\40\151\x73\x20\x61\154\x72\x65\141\x64\x79\40\162\x65\x67\151\163\x74\145\x72\145\144\x21\40\115\x61\x79\x20\157\x6e\x6c\x79\40\150\x61\166\x65\40\x65\x69\x74\x68\145\x72\40\x61\x20\104\x65\x63\x6c\x20\157\162\x20\x61\x20\104\145\143\154\122\145\146\54\x20\x6e\x6f\164\40\x62\x6f\164\150\x21");
        ZI:
        $this->authnContextDecl = $ef;
    }
    public function getAuthnContextDecl()
    {
        return $this->authnContextDecl;
    }
    public function setAuthnContextDeclRef($xk)
    {
        if (empty($this->authnContextDecl)) {
            goto QJ;
        }
        throw new Mo_SAML_Invalid_Assertion_Exception("\x41\165\x74\x68\x6e\x43\x6f\x6e\164\x65\170\164\104\x65\x63\154\x20\151\x73\x20\141\154\x72\x65\141\x64\171\x20\162\x65\147\151\163\x74\x65\x72\145\144\x21\x20\x4d\141\x79\40\x6f\156\154\x79\40\x68\141\x76\145\40\145\x69\x74\x68\x65\162\40\141\40\104\145\143\154\40\157\x72\40\141\x20\104\145\x63\x6c\122\145\x66\x2c\40\156\157\x74\x20\142\x6f\164\x68\41");
        QJ:
        $this->authnContextDeclRef = $xk;
    }
    public function getAuthnContextDeclRef()
    {
        return $this->authnContextDeclRef;
    }
    public function getAuthenticatingAuthority()
    {
        return $this->AuthenticatingAuthority;
    }
    public function setAuthenticatingAuthority($yA)
    {
        $this->AuthenticatingAuthority = $yA;
    }
    public function getAttributes()
    {
        return $this->attributes;
    }
    public function setAttributes(array $m6)
    {
        $this->attributes = $m6;
    }
    public function getAttributeNameFormat()
    {
        return $this->nameFormat;
    }
    public function setAttributeNameFormat($lp)
    {
        $this->nameFormat = $lp;
    }
    public function getSubjectConfirmation()
    {
        return $this->SubjectConfirmation;
    }
    public function setSubjectConfirmation(array $Do)
    {
        $this->SubjectConfirmation = $Do;
    }
    public function getSignatureKey()
    {
        return $this->signatureKey;
    }
    public function setSignatureKey(XMLsecurityKey $GN = NULL)
    {
        $this->signatureKey = $GN;
    }
    public function getEncryptionKey()
    {
        return $this->encryptionKey;
    }
    public function setEncryptionKey(XMLSecurityKey $rK = NULL)
    {
        $this->encryptionKey = $rK;
    }
    public function setCertificates(array $Se)
    {
        $this->certificates = $Se;
    }
    public function getCertificates()
    {
        return $this->certificates;
    }
    public function getSignatureData()
    {
        return $this->signatureData;
    }
    public function getWasSignedAtConstruction()
    {
        return $this->wasSignedAtConstruction;
    }
    public function toXML(DOMNode $We = NULL)
    {
        if ($We === NULL) {
            goto ac;
        }
        $OO = $We->ownerDocument;
        goto iz;
        ac:
        $OO = new DOMDocument();
        $We = $OO;
        iz:
        $Q8 = $OO->createElementNS("\x75\x72\156\x3a\157\x61\163\151\163\x3a\x6e\141\x6d\145\163\72\x74\x63\72\x53\x41\x4d\114\x3a\62\56\x30\72\141\x73\163\145\x72\164\x69\x6f\x6e", "\163\141\155\154\x3a" . "\101\163\163\x65\162\164\151\x6f\156");
        $We->appendChild($Q8);
        $Q8->setAttributeNS("\165\162\x6e\x3a\x6f\141\163\x69\163\x3a\156\141\x6d\145\163\72\164\x63\72\123\101\115\114\72\x32\x2e\x30\72\x70\162\157\x74\x6f\143\x6f\x6c", "\x73\x61\155\x6c\x70\72\164\155\160", "\164\x6d\x70");
        $Q8->removeAttributeNS("\165\x72\156\72\x6f\141\x73\151\x73\72\x6e\x61\155\x65\x73\72\164\143\72\x53\x41\115\x4c\72\x32\56\x30\x3a\160\x72\157\164\157\143\157\x6c", "\164\155\160");
        $Q8->setAttributeNS("\150\164\x74\160\72\57\x2f\167\167\x77\56\167\63\56\157\162\x67\x2f\x32\60\x30\x31\x2f\x58\x4d\x4c\x53\143\150\x65\155\141\x2d\x69\156\163\164\x61\x6e\143\145", "\170\x73\x69\72\x74\155\160", "\164\155\x70");
        $Q8->removeAttributeNS("\150\x74\164\160\72\57\57\167\167\x77\x2e\167\63\56\157\x72\147\x2f\x32\x30\x30\61\x2f\x58\115\x4c\x53\143\x68\x65\x6d\x61\x2d\151\x6e\x73\164\141\x6e\143\x65", "\x74\155\160");
        $Q8->setAttributeNS("\x68\164\164\160\72\57\57\x77\167\x77\56\x77\63\x2e\x6f\162\x67\57\62\60\60\x31\x2f\x58\x4d\x4c\123\x63\x68\145\155\141", "\x78\163\72\x74\155\x70", "\x74\155\x70");
        $Q8->removeAttributeNS("\150\164\x74\160\x3a\x2f\x2f\x77\x77\x77\x2e\167\x33\56\x6f\162\x67\57\x32\x30\x30\x31\x2f\x58\x4d\114\x53\143\x68\x65\x6d\x61", "\164\x6d\x70");
        $Q8->setAttribute("\111\x44", $this->id);
        $Q8->setAttribute("\126\145\x72\163\151\157\156", "\x32\x2e\60");
        $Q8->setAttribute("\x49\x73\163\165\145\111\x6e\163\x74\x61\156\164", gmdate("\x59\55\155\55\144\134\124\x48\72\151\72\163\x5c\132", $this->issueInstant));
        $rn = SAMLSPUtilities::addString($Q8, "\165\x72\156\x3a\157\141\x73\151\163\72\x6e\x61\x6d\x65\x73\x3a\x74\143\x3a\x53\x41\x4d\114\x3a\62\56\x30\x3a\141\163\x73\x65\162\164\x69\157\x6e", "\x73\141\x6d\x6c\x3a\x49\163\x73\x75\145\162", $this->issuer);
        $this->addSubject($Q8);
        $this->addConditions($Q8);
        $this->addAuthnStatement($Q8);
        if ($this->requiredEncAttributes == FALSE) {
            goto Jq;
        }
        $this->addEncryptedAttributeStatement($Q8);
        goto Ju;
        Jq:
        $this->addAttributeStatement($Q8);
        Ju:
        if (!($this->signatureKey !== NULL)) {
            goto KV;
        }
        SAMLSPUtilities::insertSignature($this->signatureKey, $this->certificates, $Q8, $rn->nextSibling);
        KV:
        return $Q8;
    }
    private function addSubject(DOMElement $Q8)
    {
        if (!($this->nameId === NULL && $this->encryptedNameId === NULL)) {
            goto Vk;
        }
        return;
        Vk:
        $Tu = $Q8->ownerDocument->createElementNS("\x75\x72\156\72\x6f\x61\163\x69\x73\x3a\x6e\141\x6d\145\163\72\x74\143\72\123\x41\x4d\114\72\62\56\60\x3a\141\163\x73\145\x72\164\x69\x6f\156", "\x73\141\155\154\72\x53\x75\x62\x6a\x65\x63\164");
        $Q8->appendChild($Tu);
        if ($this->encryptedNameId === NULL) {
            goto fc;
        }
        $Ae = $Tu->ownerDocument->createElementNS("\165\162\x6e\x3a\157\141\163\151\163\x3a\156\141\x6d\145\163\72\x74\x63\72\x53\101\x4d\114\x3a\62\x2e\60\72\141\x73\163\145\x72\164\151\x6f\156", "\x73\x61\155\154\72" . "\x45\156\143\162\171\x70\164\145\144\x49\104");
        $Tu->appendChild($Ae);
        $Ae->appendChild($Tu->ownerDocument->importNode($this->encryptedNameId, TRUE));
        goto zH;
        fc:
        SAMLSPUtilities::addNameId($Tu, $this->nameId);
        zH:
        foreach ($this->SubjectConfirmation as $M9) {
            $M9->toXML($Tu);
            i7:
        }
        Nr:
    }
    private function addConditions(DOMElement $Q8)
    {
        $OO = $Q8->ownerDocument;
        $hU = $OO->createElementNS("\x75\162\x6e\x3a\157\x61\163\151\x73\x3a\x6e\141\155\145\163\x3a\x74\143\x3a\123\x41\115\x4c\72\62\x2e\60\x3a\141\163\163\x65\162\x74\x69\x6f\x6e", "\163\x61\155\x6c\x3a\103\157\156\x64\x69\x74\151\157\156\163");
        $Q8->appendChild($hU);
        if (!($this->notBefore !== NULL)) {
            goto iv;
        }
        $hU->setAttribute("\x4e\157\x74\x42\145\146\x6f\x72\x65", gmdate("\131\x2d\x6d\55\144\134\124\110\72\x69\72\x73\x5c\x5a", $this->notBefore));
        iv:
        if (!($this->notOnOrAfter !== NULL)) {
            goto JZ;
        }
        $hU->setAttribute("\116\157\164\117\x6e\117\x72\x41\x66\164\x65\x72", gmdate("\x59\55\155\x2d\x64\x5c\x54\110\x3a\151\72\163\x5c\132", $this->notOnOrAfter));
        JZ:
        if (!($this->validAudiences !== NULL)) {
            goto AU;
        }
        $Ez = $OO->createElementNS("\165\162\x6e\x3a\x6f\141\163\151\163\72\156\x61\x6d\x65\163\72\x74\143\x3a\123\101\x4d\x4c\x3a\62\56\60\x3a\x61\163\x73\x65\162\164\x69\x6f\x6e", "\163\141\x6d\154\x3a\101\165\144\x69\145\x6e\x63\145\x52\x65\163\x74\x72\151\143\x74\x69\x6f\x6e");
        $hU->appendChild($Ez);
        SAMLSPUtilities::addStrings($Ez, "\165\x72\156\x3a\157\x61\x73\x69\x73\72\156\141\155\145\163\72\164\x63\x3a\123\101\115\x4c\x3a\x32\56\x30\72\141\163\163\145\x72\x74\151\x6f\156", "\x73\x61\x6d\154\x3a\x41\165\144\x69\145\x6e\143\145", FALSE, $this->validAudiences);
        AU:
    }
    private function addAuthnStatement(DOMElement $Q8)
    {
        if (!($this->authnInstant === NULL || $this->authnContextClassRef === NULL && $this->authnContextDecl === NULL && $this->authnContextDeclRef === NULL)) {
            goto J_;
        }
        return;
        J_:
        $OO = $Q8->ownerDocument;
        $I7 = $OO->createElementNS("\165\x72\x6e\72\157\x61\163\x69\x73\x3a\156\141\155\x65\163\72\164\143\72\123\x41\115\114\72\x32\x2e\60\x3a\x61\163\163\145\x72\164\x69\x6f\156", "\163\x61\155\154\72\101\x75\x74\150\156\x53\164\x61\164\145\x6d\145\156\x74");
        $Q8->appendChild($I7);
        $I7->setAttribute("\101\x75\164\150\x6e\111\156\163\164\x61\x6e\164", gmdate("\x59\55\x6d\x2d\144\x5c\x54\x48\72\151\x3a\163\x5c\132", $this->authnInstant));
        if (!($this->sessionNotOnOrAfter !== NULL)) {
            goto fB;
        }
        $I7->setAttribute("\x53\x65\163\163\151\157\156\x4e\x6f\164\x4f\x6e\117\x72\x41\146\x74\145\162", gmdate("\131\55\155\55\144\x5c\124\110\x3a\151\72\163\x5c\x5a", $this->sessionNotOnOrAfter));
        fB:
        if (!($this->sessionIndex !== NULL)) {
            goto t7;
        }
        $I7->setAttribute("\x53\145\163\163\x69\x6f\156\x49\156\x64\x65\170", $this->sessionIndex);
        t7:
        $Zb = $OO->createElementNS("\165\162\156\72\x6f\141\163\151\163\72\156\x61\x6d\145\x73\x3a\164\143\72\x53\x41\x4d\114\72\62\x2e\60\72\141\x73\x73\x65\x72\164\x69\157\156", "\x73\141\x6d\x6c\x3a\101\x75\x74\150\x6e\x43\157\156\x74\x65\170\164");
        $I7->appendChild($Zb);
        if (empty($this->authnContextClassRef)) {
            goto gN;
        }
        SAMLSPUtilities::addString($Zb, "\x75\x72\x6e\72\157\141\x73\x69\163\x3a\x6e\141\x6d\145\x73\72\x74\x63\72\123\101\115\114\x3a\62\56\60\x3a\x61\x73\x73\x65\x72\x74\x69\x6f\x6e", "\x73\x61\155\x6c\x3a\x41\165\x74\x68\x6e\x43\157\x6e\x74\145\170\164\x43\x6c\141\163\163\122\x65\146", $this->authnContextClassRef);
        gN:
        if (empty($this->authnContextDecl)) {
            goto ns;
        }
        $this->authnContextDecl->toXML($Zb);
        ns:
        if (empty($this->authnContextDeclRef)) {
            goto US;
        }
        SAMLSPUtilities::addString($Zb, "\165\162\x6e\72\x6f\x61\163\x69\163\x3a\x6e\x61\155\x65\163\x3a\164\x63\x3a\123\x41\115\114\x3a\x32\56\x30\x3a\x61\x73\163\x65\162\164\151\x6f\x6e", "\163\x61\155\154\72\101\165\164\x68\156\103\x6f\156\x74\145\170\164\104\145\x63\x6c\122\145\x66", $this->authnContextDeclRef);
        US:
        SAMLSPUtilities::addStrings($Zb, "\165\x72\156\x3a\x6f\141\163\151\163\72\x6e\x61\x6d\x65\x73\72\x74\143\x3a\x53\x41\115\x4c\72\62\56\60\x3a\x61\163\163\x65\x72\164\x69\157\156", "\x73\141\155\154\x3a\101\x75\x74\150\x65\x6e\x74\x69\x63\141\164\x69\156\x67\x41\x75\164\150\x6f\162\x69\164\x79", FALSE, $this->AuthenticatingAuthority);
    }
    private function addAttributeStatement(DOMElement $Q8)
    {
        if (!empty($this->attributes)) {
            goto TO;
        }
        return;
        TO:
        $OO = $Q8->ownerDocument;
        $dh = $OO->createElementNS("\x75\162\x6e\72\157\x61\x73\x69\163\x3a\x6e\x61\155\x65\163\72\x74\143\72\x53\101\115\x4c\x3a\x32\56\x30\x3a\x61\163\x73\x65\162\164\x69\x6f\x6e", "\163\141\155\x6c\x3a\x41\164\x74\162\151\x62\x75\x74\x65\123\164\x61\164\145\x6d\145\x6e\164");
        $Q8->appendChild($dh);
        foreach ($this->attributes as $KC => $BT) {
            $ZG = $OO->createElementNS("\x75\162\156\72\x6f\x61\x73\151\163\x3a\156\141\x6d\145\x73\72\164\x63\x3a\123\x41\115\114\x3a\62\56\x30\72\x61\x73\x73\145\x72\164\x69\157\x6e", "\x73\x61\155\154\x3a\x41\164\x74\x72\x69\142\x75\x74\x65");
            $dh->appendChild($ZG);
            $ZG->setAttribute("\x4e\141\155\x65", $KC);
            if (!($this->nameFormat !== "\165\162\156\x3a\157\x61\163\x69\x73\x3a\x6e\141\155\x65\163\72\164\x63\x3a\123\101\115\x4c\72\62\x2e\x30\x3a\141\164\164\162\x6e\x61\155\145\x2d\146\x6f\x72\x6d\x61\x74\72\x75\x6e\163\x70\145\143\x69\x66\x69\145\x64")) {
                goto tW;
            }
            $ZG->setAttribute("\x4e\141\x6d\145\x46\157\162\155\141\x74", $this->nameFormat);
            tW:
            foreach ($BT as $lj) {
                if (is_string($lj)) {
                    goto j0;
                }
                if (is_int($lj)) {
                    goto jY;
                }
                $sV = NULL;
                goto mA;
                j0:
                $sV = "\170\x73\72\x73\x74\x72\x69\156\147";
                goto mA;
                jY:
                $sV = "\x78\163\x3a\151\156\164\x65\147\x65\x72";
                mA:
                $Nu = $OO->createElementNS("\165\x72\x6e\x3a\157\x61\163\x69\x73\x3a\156\141\x6d\x65\x73\x3a\x74\143\72\x53\x41\115\114\72\62\x2e\x30\x3a\x61\163\x73\145\162\x74\151\157\x6e", "\x73\x61\x6d\154\x3a\101\x74\164\162\x69\x62\x75\x74\145\x56\141\154\x75\145");
                $ZG->appendChild($Nu);
                if (!($sV !== NULL)) {
                    goto C2;
                }
                $Nu->setAttributeNS("\150\x74\164\x70\72\57\x2f\167\x77\167\56\x77\x33\x2e\x6f\162\147\x2f\62\x30\x30\61\x2f\130\x4d\x4c\123\143\x68\145\x6d\x61\55\151\156\163\x74\x61\156\x63\145", "\170\163\x69\x3a\x74\x79\x70\x65", $sV);
                C2:
                if (!is_null($lj)) {
                    goto hG;
                }
                $Nu->setAttributeNS("\150\164\164\160\x3a\57\x2f\x77\167\x77\x2e\167\x33\x2e\x6f\162\147\x2f\62\60\x30\x31\x2f\x58\115\114\x53\143\150\x65\x6d\x61\x2d\151\156\x73\164\141\x6e\x63\145", "\170\x73\x69\72\x6e\x69\x6c", "\x74\x72\165\x65");
                hG:
                if ($lj instanceof DOMNodeList) {
                    goto hQ;
                }
                $Nu->appendChild($OO->createTextNode($lj));
                goto yH;
                hQ:
                $Hf = 0;
                cL:
                if (!($Hf < $lj->length)) {
                    goto v1;
                }
                $Vg = $OO->importNode($lj->item($Hf), TRUE);
                $Nu->appendChild($Vg);
                kZ:
                $Hf++;
                goto cL;
                v1:
                yH:
                ts:
            }
            TX:
            V4:
        }
        NV:
    }
    private function addEncryptedAttributeStatement(DOMElement $Q8)
    {
        if (!($this->requiredEncAttributes == FALSE)) {
            goto t_;
        }
        return;
        t_:
        $OO = $Q8->ownerDocument;
        $dh = $OO->createElementNS("\x75\162\156\x3a\157\141\x73\x69\x73\x3a\x6e\x61\x6d\145\163\72\x74\x63\x3a\123\x41\115\114\x3a\62\56\x30\x3a\x61\163\163\145\x72\164\x69\157\x6e", "\163\141\155\154\72\101\164\164\162\x69\142\165\164\145\x53\164\141\x74\x65\155\x65\156\164");
        $Q8->appendChild($dh);
        foreach ($this->attributes as $KC => $BT) {
            $Dm = new DOMDocument();
            $ZG = $Dm->createElementNS("\x75\x72\156\x3a\157\x61\x73\x69\163\x3a\156\x61\x6d\145\163\x3a\164\x63\72\x53\x41\x4d\114\72\62\x2e\60\72\x61\163\x73\145\162\164\151\x6f\156", "\x73\141\155\x6c\x3a\x41\x74\x74\x72\x69\x62\165\x74\x65");
            $ZG->setAttribute("\x4e\x61\x6d\x65", $KC);
            $Dm->appendChild($ZG);
            if (!($this->nameFormat !== "\165\x72\156\x3a\x6f\141\163\x69\x73\72\x6e\x61\155\x65\163\72\164\x63\x3a\x53\101\x4d\114\72\62\56\x30\x3a\x61\164\x74\162\156\x61\155\145\x2d\x66\x6f\162\x6d\x61\x74\x3a\165\156\x73\x70\145\143\x69\x66\x69\145\144")) {
                goto Is;
            }
            $ZG->setAttribute("\x4e\141\155\145\106\x6f\x72\155\141\x74", $this->nameFormat);
            Is:
            foreach ($BT as $lj) {
                if (is_string($lj)) {
                    goto TB;
                }
                if (is_int($lj)) {
                    goto U6;
                }
                $sV = NULL;
                goto rV;
                TB:
                $sV = "\170\x73\72\163\164\162\x69\x6e\147";
                goto rV;
                U6:
                $sV = "\x78\163\72\x69\x6e\x74\145\x67\145\x72";
                rV:
                $Nu = $Dm->createElementNS("\165\x72\156\x3a\x6f\141\163\x69\x73\72\x6e\x61\x6d\145\163\72\x74\143\x3a\x53\101\x4d\x4c\x3a\62\x2e\x30\72\x61\163\x73\145\162\164\151\157\x6e", "\163\141\155\x6c\72\101\164\x74\x72\x69\142\165\164\x65\x56\141\154\165\145");
                $ZG->appendChild($Nu);
                if (!($sV !== NULL)) {
                    goto WB;
                }
                $Nu->setAttributeNS("\x68\164\x74\160\x3a\57\x2f\x77\x77\167\56\167\63\56\x6f\x72\147\x2f\62\60\60\x31\57\x58\x4d\x4c\123\x63\x68\x65\155\141\55\x69\156\x73\164\141\x6e\x63\x65", "\170\163\151\x3a\164\x79\160\145", $sV);
                WB:
                if ($lj instanceof DOMNodeList) {
                    goto BA;
                }
                $Nu->appendChild($Dm->createTextNode($lj));
                goto hS;
                BA:
                $Hf = 0;
                LJ:
                if (!($Hf < $lj->length)) {
                    goto c9;
                }
                $Vg = $Dm->importNode($lj->item($Hf), TRUE);
                $Nu->appendChild($Vg);
                rb:
                $Hf++;
                goto LJ;
                c9:
                hS:
                Vt:
            }
            bL:
            $QR = new XMLSecEnc();
            $QR->setNode($Dm->documentElement);
            $QR->type = "\150\164\x74\160\72\57\57\x77\x77\167\56\x77\63\56\157\162\147\x2f\62\x30\60\61\57\60\x34\x2f\x78\155\154\145\156\x63\x23\105\x6c\x65\155\x65\x6e\164";
            $jp = new XMLSecurityKey(XMLSecurityKey::AES256_CBC);
            $jp->generateSessionKey();
            $QR->encryptKey($this->encryptionKey, $jp);
            $J8 = $QR->encryptNode($jp);
            $dO = $OO->createElementNS("\x75\x72\x6e\x3a\x6f\141\163\x69\163\72\156\141\x6d\x65\163\72\164\x63\72\123\101\x4d\x4c\72\62\x2e\60\72\141\x73\163\145\162\x74\151\x6f\x6e", "\x73\141\155\x6c\72\105\x6e\143\x72\x79\160\x74\145\144\101\x74\x74\x72\x69\x62\x75\164\145");
            $dh->appendChild($dO);
            $RN = $OO->importNode($J8, TRUE);
            $dO->appendChild($RN);
            Ip:
        }
        q5:
    }
    public function getPrivateKeyUrl()
    {
        return $this->privateKeyUrl;
    }
    public function setPrivateKeyUrl($L0)
    {
        $this->privateKeyUrl = $L0;
    }
}
