<?php
/**
 * This file is a part of the miniorange-saml-20-single-sign-on plugin.
 *
 * @link https://plugins.miniorange.com/
 * @author miniOrange
 * @package miniorange-saml-20-single-sign-on
 */


use RobRichards\XMLSecLibs\XMLSecurityKey;
use RobRichards\XMLSecLibs\XMLSecurityDSig;
use RobRichards\XMLSecLibs\XMLSecEnc;
class SAML2SPLogoutRequest
{
    private $tagName;
    private $id;
    private $issuer;
    private $destination;
    private $issueInstant;
    private $certificates;
    private $validators;
    private $notOnOrAfter;
    private $encryptedNameId;
    private $nameId;
    private $sessionIndexes;
    public function __construct(DOMElement $jx = NULL)
    {
        $this->tagName = "\114\x6f\147\x6f\x75\164\x52\x65\x71\x75\145\163\164";
        $this->id = SAMLSPUtilities::generateID();
        $this->issueInstant = time();
        $this->certificates = array();
        $this->validators = array();
        if (!($jx === NULL)) {
            goto et;
        }
        return;
        et:
        if ($jx->hasAttribute("\111\104")) {
            goto Re;
        }
        throw new Mo_SAML_Invalid_Logout_Request_Exception("\x4d\x69\x73\163\151\156\147\x20\x49\104\x20\x61\x74\164\x72\x69\x62\165\x74\145\40\157\156\40\x53\x41\115\114\x20\x6d\145\x73\x73\141\147\145\x2e");
        Re:
        $this->id = $jx->getAttribute("\x49\x44");
        if (!($jx->getAttribute("\126\x65\x72\x73\151\x6f\x6e") !== "\x32\56\x30")) {
            goto JV;
        }
        throw new Mo_SAML_Invalid_Logout_Request_Exception("\x55\x6e\x73\165\160\160\x6f\x72\164\x65\144\x20\x76\x65\162\x73\151\x6f\x6e\x3a\40" . $jx->getAttribute("\126\x65\162\163\x69\x6f\156"));
        JV:
        $this->issueInstant = SAMLSPUtilities::xsDateTimeToTimestamp($jx->getAttribute("\x49\x73\x73\x75\145\x49\156\163\164\141\x6e\164"));
        if (!$jx->hasAttribute("\104\x65\x73\164\x69\156\x61\164\x69\157\x6e")) {
            goto Hv;
        }
        $this->destination = $jx->getAttribute("\x44\x65\x73\164\151\156\141\164\x69\157\156");
        Hv:
        $rn = SAMLSPUtilities::xpQuery($jx, "\56\x2f\x73\x61\x6d\154\137\x61\163\x73\145\162\x74\x69\x6f\x6e\72\x49\x73\x73\x75\x65\162");
        if (empty($rn)) {
            goto e0;
        }
        $this->issuer = trim($rn[0]->textContent);
        e0:
        try {
            $df = SAMLSPUtilities::validateElement($jx);
            if (!($df !== FALSE)) {
                goto kE;
            }
            $this->certificates = $df["\x43\x65\162\164\151\x66\x69\143\x61\x74\x65\x73"];
            $this->validators[] = array("\x46\165\156\x63\164\151\157\156" => array("\x55\x74\151\x6c\151\x74\x69\145\x73", "\166\141\154\151\x64\x61\x74\x65\x53\x69\x67\x6e\x61\164\165\162\x65"), "\104\x61\x74\141" => $df);
            kE:
        } catch (Exception $V1) {
        }
        $this->sessionIndexes = array();
        if (!$jx->hasAttribute("\116\x6f\x74\x4f\156\x4f\162\101\x66\164\145\x72")) {
            goto uW;
        }
        $this->notOnOrAfter = SAMLSPUtilities::xsDateTimeToTimestamp($jx->getAttribute("\116\x6f\164\x4f\x6e\117\x72\101\146\x74\x65\x72"));
        uW:
        $IW = SAMLSPUtilities::xpQuery($jx, "\56\x2f\163\x61\155\x6c\137\141\x73\163\145\162\x74\x69\157\x6e\x3a\x4e\x61\155\145\x49\x44\40\174\x20\56\x2f\x73\x61\155\154\137\x61\163\163\145\162\x74\151\x6f\156\x3a\x45\x6e\x63\162\171\160\x74\145\x64\111\x44\57\170\x65\x6e\143\x3a\105\x6e\x63\162\x79\x70\164\x65\x64\x44\x61\x74\x61");
        if (empty($IW)) {
            goto xt;
        }
        if (count($IW) > 1) {
            goto cT;
        }
        goto oa;
        xt:
        throw new Mo_SAML_Invalid_Logout_Request_Exception("\115\x69\x73\x73\151\x6e\x67\x20\x3c\163\x61\155\154\72\x4e\x61\x6d\x65\111\x44\x3e\40\x6f\x72\40\x3c\x73\x61\155\x6c\72\105\156\143\162\171\160\164\x65\x64\111\x44\x3e\40\151\156\40\x3c\163\141\x6d\x6c\160\72\x4c\157\x67\x6f\165\x74\122\x65\161\x75\145\163\164\76\56");
        goto oa;
        cT:
        throw new Mo_SAML_Invalid_Logout_Request_Exception("\x4d\x6f\x72\145\x20\164\150\141\x6e\x20\x6f\x6e\x65\x20\x3c\163\x61\155\x6c\72\x4e\141\x6d\145\x49\104\x3e\x20\157\162\x20\x3c\x73\x61\155\x6c\x3a\x45\156\x63\x72\171\x70\164\145\x64\104\x3e\40\x69\x6e\x20\74\x73\141\x6d\x6c\x70\72\114\x6f\147\x6f\x75\x74\x52\x65\161\165\x65\x73\x74\76\x2e");
        oa:
        $IW = $IW[0];
        if ($IW->localName === "\x45\x6e\143\x72\x79\160\x74\145\x64\104\x61\164\141") {
            goto aC;
        }
        $this->nameId = SAMLSPUtilities::parseNameId($IW);
        goto N9;
        aC:
        $this->encryptedNameId = $IW;
        N9:
        $uE = SAMLSPUtilities::xpQuery($jx, "\x2e\57\163\141\155\154\137\x70\x72\x6f\164\157\143\x6f\154\72\x53\145\x73\x73\x69\157\156\x49\x6e\x64\x65\x78");
        foreach ($uE as $MR) {
            $this->sessionIndexes[] = trim($MR->textContent);
            LQ:
        }
        dp:
    }
    public function getNotOnOrAfter()
    {
        return $this->notOnOrAfter;
    }
    public function setNotOnOrAfter($jY)
    {
        $this->notOnOrAfter = $jY;
    }
    public function isNameIdEncrypted()
    {
        if (!($this->encryptedNameId !== NULL)) {
            goto ya;
        }
        return TRUE;
        ya:
        return FALSE;
    }
    public function encryptNameId(XMLSecurityKey $mj)
    {
        $dk = new DOMDocument();
        $Q8 = $dk->createElement("\x72\157\157\x74");
        $dk->appendChild($Q8);
        SAML2_Utils::addNameId($Q8, $this->nameId);
        $IW = $Q8->firstChild;
        SAML2_Utils::getContainer()->debugMessage($IW, "\x65\156\143\162\x79\160\x74");
        $Ll = new XMLSecEnc();
        $Ll->setNode($IW);
        $Ll->type = XMLSecEnc::Element;
        $jp = new XMLSecurityKey(XMLSecurityKey::AES128_CBC);
        $jp->generateSessionKey();
        $Ll->encryptKey($mj, $jp);
        $this->encryptedNameId = $Ll->encryptNode($jp);
        $this->nameId = NULL;
    }
    public function decryptNameId(XMLSecurityKey $mj, array $Ma = array())
    {
        if (!($this->encryptedNameId === NULL)) {
            goto Ux;
        }
        return;
        Ux:
        $IW = SAML2_Utils::decryptElement($this->encryptedNameId, $mj, $Ma);
        SAML2_Utils::getContainer()->debugMessage($IW, "\x64\145\143\x72\171\x70\164");
        $this->nameId = SAML2_Utils::parseNameId($IW);
        $this->encryptedNameId = NULL;
    }
    public function getNameId()
    {
        if (!($this->encryptedNameId !== NULL)) {
            goto tb;
        }
        throw new Mo_SAML_Invalid_Logout_Request_Exception("\101\x74\x74\x65\155\160\x74\x65\144\x20\x74\157\40\162\x65\164\x72\151\x65\166\145\x20\145\156\x63\x72\171\160\x74\x65\x64\x20\116\x61\155\x65\x49\104\40\x77\x69\164\150\157\x75\x74\x20\144\x65\x63\x72\171\160\164\151\x6e\x67\x20\151\x74\x20\146\151\162\163\x74\x2e");
        tb:
        return $this->nameId;
    }
    public function setNameId($IW)
    {
        $this->nameId = $IW;
    }
    public function getSessionIndexes()
    {
        return $this->sessionIndexes;
    }
    public function setSessionIndexes(array $uE)
    {
        $this->sessionIndexes = $uE;
    }
    public function getSessionIndex()
    {
        if (!empty($this->sessionIndexes)) {
            goto DV;
        }
        return NULL;
        DV:
        return $this->sessionIndexes[0];
    }
    public function setSessionIndex($MR)
    {
        if (is_null($MR)) {
            goto qB;
        }
        $this->sessionIndexes = array($MR);
        goto aQ;
        qB:
        $this->sessionIndexes = array();
        aQ:
    }
    public function getId()
    {
        return $this->id;
    }
    public function setId($uS)
    {
        $this->id = $uS;
    }
    public function getIssueInstant()
    {
        return $this->issueInstant;
    }
    public function setIssueInstant($CF)
    {
        $this->issueInstant = $CF;
    }
    public function getDestination()
    {
        return $this->destination;
    }
    public function setDestination($Sb)
    {
        $this->destination = $Sb;
    }
    public function getIssuer()
    {
        return $this->issuer;
    }
    public function setIssuer($rn)
    {
        $this->issuer = $rn;
    }
}
