<?php
/**
 * This file is a part of the miniorange-saml-20-single-sign-on plugin.
 *
 * @link https://plugins.miniorange.com/
 * @author miniOrange
 * @package miniorange-saml-20-single-sign-on
 */


class IDPMetadataReader
{
    private $identityProviders;
    private $serviceProviders;
    public function __construct(DOMNode $jx = NULL)
    {
        $this->identityProviders = array();
        $this->serviceProviders = array();
        $gg = SAMLSPUtilities::xpQuery($jx, "\56\x2f\163\141\x6d\154\137\x6d\145\x74\x61\x64\x61\164\x61\72\x45\156\x74\x69\x74\x69\x65\163\x44\145\163\x63\x72\x69\160\164\x6f\x72");
        if (!empty($gg)) {
            goto H3;
        }
        $Q_ = SAMLSPUtilities::xpQuery($jx, "\x2e\57\163\141\155\154\137\x6d\145\164\141\144\x61\164\x61\72\105\x6e\164\x69\x74\x79\x44\145\163\x63\162\x69\160\x74\157\162");
        goto zi;
        H3:
        $Q_ = SAMLSPUtilities::xpQuery($gg[0], "\x2e\57\x73\x61\155\x6c\x5f\155\145\x74\141\144\x61\x74\x61\x3a\x45\156\164\x69\x74\x79\104\145\163\x63\162\151\160\164\x6f\x72");
        zi:
        foreach ($Q_ as $Zn) {
            $mR = SAMLSPUtilities::xpQuery($Zn, "\56\x2f\x73\141\155\154\x5f\x6d\145\164\x61\144\x61\164\141\x3a\x49\104\120\123\123\x4f\x44\145\163\x63\162\151\160\x74\157\x72");
            if (empty($mR)) {
                goto yQ;
            }
            array_push($this->identityProviders, new IdentityProviders($Zn));
            yQ:
            IH:
        }
        o1:
    }
    public function getIdentityProviders()
    {
        return $this->identityProviders;
    }
    public function getServiceProviders()
    {
        return $this->serviceProviders;
    }
}
class IdentityProviders
{
    private $idpName;
    private $entityID;
    private $loginDetails;
    private $logoutDetails;
    private $nameIdFormat;
    private $signingCertificate;
    private $encryptionCertificate;
    private $signedRequest;
    private $name_id_format;
    public function __construct(DOMElement $jx = NULL)
    {
        $this->idpName = '';
        $this->loginDetails = array();
        $this->logoutDetails = array();
        $this->nameIdFormat = array();
        $this->signingCertificate = array();
        $this->encryptionCertificate = array();
        if (!$jx->hasAttribute("\x65\x6e\164\151\x74\171\x49\104")) {
            goto jD;
        }
        $this->entityID = $jx->getAttribute("\145\156\x74\x69\x74\171\x49\x44");
        jD:
        $mR = SAMLSPUtilities::xpQuery($jx, "\56\57\x73\141\155\x6c\137\x6d\145\164\141\144\141\164\141\x3a\x49\104\x50\123\123\117\104\145\163\x63\x72\x69\x70\164\x6f\162");
        if (count($mR) > 1) {
            goto YH;
        }
        if (empty($mR)) {
            goto z8;
        }
        goto vh;
        YH:
        throw new Mo_SAML_Metadata_Reader_Exception("\x4d\x6f\162\x65\40\x74\150\x61\x6e\x20\x6f\156\x65\x20\x3c\x49\x44\x50\x53\123\x4f\104\x65\163\x63\x72\151\160\164\157\x72\76\x20\151\156\x20\x3c\x45\156\x74\x69\x74\171\x44\x65\x73\143\x72\151\x70\164\x6f\162\76\x2e");
        goto vh;
        z8:
        throw new Mo_SAML_Metadata_Reader_Exception("\115\x69\x73\x73\x69\156\147\x20\162\x65\x71\x75\x69\162\x65\144\40\x3c\x49\104\x50\x53\x53\x4f\104\145\x73\143\x72\151\x70\x74\x6f\162\x3e\x20\151\156\x20\x3c\x45\x6e\x74\151\x74\x79\104\x65\163\x63\162\x69\x70\164\x6f\x72\76\x2e");
        vh:
        $Eq = $mR[0];
        $this->parseWantAuthnRequestsSigned($Eq);
        $zS = SAMLSPUtilities::xpQuery($jx, "\x2e\x2f\x73\x61\x6d\154\x5f\155\145\164\x61\144\141\x74\x61\x3a\105\170\x74\145\x6e\163\x69\157\156\x73");
        if (!$zS) {
            goto Zt;
        }
        $this->parseInfo($Eq);
        Zt:
        $this->parseSSOService($Eq);
        $this->parseSLOService($Eq);
        $this->parseNameIdFormat($Eq);
        $this->parsex509Certificate($Eq);
        $this->parse_name_id_format($Eq);
    }
    private function parse_name_id_format($jx)
    {
        $EH = SAMLSPUtilities::xpQuery($jx, "\x2e\57\x73\x61\x6d\154\137\155\145\x74\x61\x64\x61\x74\141\72\116\x61\155\145\111\x44\x46\157\162\155\x61\164");
        if (empty($EH)) {
            goto rH;
        }
        $y_ = SAMLSPUtilities::get_valid_name_id_format($EH);
        goto po;
        rH:
        $y_ = Mo_Saml_Options_Enum_Nameid_Formats::UNSPECIFIED;
        po:
        $this->name_id_format = str_replace("\x75\162\156\72\157\x61\x73\151\163\72\x6e\x61\155\x65\163\72\164\143\x3a\x53\101\115\x4c\x3a", '', $y_);
    }
    private function parseInfo($jx)
    {
        $A9 = SAMLSPUtilities::xpQuery($jx, "\56\57\x6d\x64\165\151\x3a\x55\x49\111\156\x66\157\x2f\x6d\x64\x75\151\72\x44\151\163\x70\154\141\171\116\x61\155\145");
        foreach ($A9 as $KC) {
            if (!($KC->hasAttribute("\x78\155\x6c\x3a\x6c\141\x6e\147") && $KC->getAttribute("\x78\x6d\154\72\x6c\141\x6e\147") == "\x65\156")) {
                goto Fr;
            }
            $this->idpName = $KC->textContent;
            Fr:
            Fi:
        }
        zx:
    }
    private function parseSSOService($jx)
    {
        $Xn = SAMLSPUtilities::xpQuery($jx, "\56\57\x73\x61\x6d\x6c\137\155\x65\164\x61\x64\141\164\141\72\123\151\x6e\147\154\x65\x53\x69\147\156\x4f\x6e\123\x65\x72\166\x69\x63\145");
        foreach ($Xn as $nc) {
            $Sm = str_replace("\x75\162\156\72\157\141\163\151\x73\x3a\156\x61\x6d\145\x73\72\164\143\72\x53\101\115\x4c\x3a\x32\x2e\60\x3a\x62\151\x6e\x64\151\156\147\x73\72", '', $nc->getAttribute("\x42\x69\x6e\144\x69\156\x67"));
            $this->loginDetails = array_merge($this->loginDetails, array($Sm => $nc->getAttribute("\x4c\157\143\141\x74\151\x6f\156")));
            es:
        }
        oX:
    }
    private function parseSLOService($jx)
    {
        $qz = SAMLSPUtilities::xpQuery($jx, "\x2e\57\163\141\x6d\x6c\x5f\155\x65\164\141\x64\x61\x74\141\72\123\x69\156\147\154\x65\114\157\x67\157\x75\x74\123\145\162\166\151\143\x65");
        if (!empty($qz)) {
            goto Ut;
        }
        $this->logoutDetails = array("\x48\x54\x54\x50\x2d\x52\145\x64\151\x72\x65\143\164" => '');
        goto EH;
        Ut:
        foreach ($qz as $wC) {
            $Sm = str_replace("\165\162\156\x3a\x6f\x61\x73\x69\163\72\x6e\141\155\145\x73\72\164\143\72\123\x41\115\114\72\62\x2e\x30\x3a\142\151\156\144\x69\x6e\147\163\x3a", '', $wC->getAttribute("\x42\x69\156\144\x69\156\x67"));
            $this->logoutDetails = array_merge($this->logoutDetails, array($Sm => $wC->getAttribute("\x4c\x6f\x63\141\164\151\157\x6e")));
            zl:
        }
        mN:
        EH:
    }
    private function parseNameIdFormat($jx)
    {
        $Pl = SAMLSPUtilities::xpQuery($jx, "\x2e\x2f\x73\x61\x6d\x6c\x5f\155\145\164\x61\144\141\x74\x61\72\116\x61\x6d\x65\111\x44\x46\157\162\155\x61\x74");
        foreach ($Pl as $Er) {
            $M6 = str_replace("\165\x72\156\x3a\x6f\141\163\151\x73\72\x6e\x61\155\x65\x73\x3a\164\x63\72\x53\101\x4d\114\72", '', $Er->nodeValue);
            $this->nameIdFormat = array_merge($this->nameIdFormat, array($M6));
            qp:
        }
        zq:
    }
    private function parsex509Certificate($jx)
    {
        foreach (SAMLSPUtilities::xpQuery($jx, "\56\x2f\x73\x61\155\x6c\x5f\x6d\145\164\x61\x64\x61\x74\x61\72\113\x65\171\104\x65\163\143\162\151\160\x74\157\162") as $zf) {
            if ($zf->hasAttribute("\x75\x73\145")) {
                goto P1;
            }
            $this->parseSigningCertificate($zf);
            goto p6;
            P1:
            if ($zf->getAttribute("\165\163\x65") == "\x65\x6e\x63\x72\171\x70\x74\151\x6f\x6e") {
                goto lE;
            }
            $this->parseSigningCertificate($zf);
            goto kO;
            lE:
            $this->parseEncryptionCertificate($zf);
            kO:
            p6:
            Fb:
        }
        dc:
    }
    private function parseWantAuthnRequestsSigned($jx)
    {
        if (!$jx->hasAttribute("\x57\x61\156\164\x41\x75\x74\x68\x6e\122\145\x71\x75\145\x73\164\x73\123\151\x67\x6e\145\x64")) {
            goto Tp;
        }
        $this->signedRequest = $jx->getAttribute("\127\x61\156\164\x41\165\x74\x68\156\122\x65\161\x75\x65\x73\x74\163\x53\151\x67\x6e\145\144");
        Tp:
    }
    private function parseSigningCertificate($jx)
    {
        $wQ = SAMLSPUtilities::xpQuery($jx, "\x2e\x2f\144\x73\x3a\x4b\x65\x79\x49\x6e\146\157\57\x64\x73\x3a\x58\65\60\71\104\x61\x74\141\57\144\163\72\x58\x35\60\71\103\145\162\x74\x69\x66\151\x63\x61\164\145");
        $ha = trim($wQ[0]->textContent);
        $ha = str_replace(array("\xd", "\xa", "\11", "\40"), '', $ha);
        if (empty($wQ)) {
            goto Y6;
        }
        array_push($this->signingCertificate, SAMLSPUtilities::sanitize_certificate($ha));
        Y6:
    }
    private function parseEncryptionCertificate($jx)
    {
        $wQ = SAMLSPUtilities::xpQuery($jx, "\56\57\x64\x73\x3a\x4b\x65\x79\111\156\146\157\x2f\x64\x73\72\x58\x35\60\71\104\x61\164\141\57\x64\x73\72\x58\x35\60\x39\x43\x65\x72\164\x69\x66\x69\x63\141\x74\145");
        $ha = trim($wQ[0]->textContent);
        $ha = str_replace(array("\xd", "\xa", "\x9", "\x20"), '', $ha);
        if (empty($wQ)) {
            goto fh;
        }
        array_push($this->encryptionCertificate, $ha);
        fh:
    }
    public function getIdpName()
    {
        return $this->idpName;
    }
    public function getEntityID()
    {
        return $this->entityID;
    }
    public function getLoginURL($Sm)
    {
        return $this->loginDetails[$Sm];
    }
    public function getLogoutURL($Sm)
    {
        return $this->logoutDetails[$Sm];
    }
    public function getLoginDetails()
    {
        return $this->loginDetails;
    }
    public function getLogoutDetails()
    {
        return $this->logoutDetails;
    }
    public function getNameIdFormats()
    {
        return $this->nameIdFormat;
    }
    public function getSigningCertificate()
    {
        return $this->signingCertificate;
    }
    public function getEncryptionCertificate()
    {
        return $this->encryptionCertificate[0];
    }
    public function isRequestSigned()
    {
        return $this->signedRequest;
    }
    public function get_name_id_format()
    {
        return $this->name_id_format;
    }
}
class ServiceProviders
{
}
